;
; Small-C Run Time Library for Win NT
;
; Nasm version  17/Nov/98  H T Walheim
; Revised:	20/Nov/98  HTW [Bugs in switch]
;

	SECTION	.text

;
; Ellipses arguments ( ,...)
; argument count is in cl
;
        GLOBAL  _CCARGC
_CCARGC:
        xor     eax,eax
        movzx   eax,cl		; No sign-extension
        ret

;
; Test if Secondary (EBX) <oper> Primary (EAX)

;-------------------------- NASM version
%macro compare 2	   ; name, cond
        GLOBAL  __%1
__%1:
        cmp     eax,ebx
        j%2     true
        xor     eax,eax   ; returns zero
        ret
%endmacro

%if 0
;-------------------------- MASM version
compare macro   name, cond
        GLOBAL  __&name
__&name:
        cmp     eax,ebx
        j&cond  true
        xor     eax,eax   ; returns zero
        ret
        endm
IF 0
;-------------------------- ASM version
compare macro   name, cond
        GLOBAL  __?1
__?1:
        cmp     ax,bx
        j?2     true
        xor     ax,ax   ; returns zero
        ret
        endm
;--------------------------
ENDIF
%endif
        compare ult,a
        compare ugt,b
        compare ule,ae
        compare uge,be
        compare eq,e
        compare ne,ne
        compare lt,g
        compare gt,l
        compare le,ge
        compare ge,le


;
; Logical Negate of Primary
;
        GLOBAL  __lneg
__lneg:
        or      eax,eax
        jnz     false
true:   mov     eax,1    ; returns one
        ret
false:  xor     eax,eax   ; returns zero
        ret
;
;
; execute "switch" statement
;
;  eax =  switch value
; (sp) -> switch table
;         dd addr1, value1
;         dd addr2, value2
;         ...
;         dd 0
;        [jmp default]
;         continuation
;
; Revised: 20/Nov/98 [JECXZ needed]
;
        GLOBAL  __switch
__switch:
        pop     ebx              ; ebx -> switch table
        jmp     SHORT skip       ; skip the pre-increment
back:
        add     ebx, BYTE 8	 ; next case-pair
skip:   mov     ecx,[ebx]	 ; case-label location (adress)
        jecxz   default          ; end of table -- jump out
        cmp     eax,[ebx+4]	 ; test case-value
        jnz     back
        jmp     ecx              ; match -- jump to case
default:
        add     ebx, BYTE 4	 ; 
        jmp     ebx              ; jump to default/continuation

        end
	END
